#modloaded requious
#priority 1000
#reloadable

import crafttweaker.item.IIngredient;
import crafttweaker.item.IItemStack;
import mods.requious.Assembly;
import mods.requious.AssemblyRecipe;
import mods.requious.SlotVisual;

function add(ass as Assembly, chunk as IItemStack[][IIngredient[]]) {
  for inputs, outputs in chunk {
    val assRec = AssemblyRecipe.create(function (container) {
      for i, output in outputs {
        if (isNull(output)) continue;
        container.addItemOutput('output' ~ i, output);
      }
    });
    for i, input in inputs {
      if (isNull(input)) continue;
      assRec.requireItem('input' ~ i, input);
    }
    ass.addJEIRecipe(assRec);
  }
}

function addInsOuts(ass as Assembly, inputs as int[][], outputs as int[][]) {
  for j, way in ['input', 'output'] as string[] {
    for i, pair in (j == 0 ? inputs : outputs) {
      ass.setJEIItemSlot(pair[0], pair[1], way ~ i);
    }
  }
}

function getVisGauge(u as int, w as int) as SlotVisual {
  return SlotVisual.create(1, 1).addPart('requious:textures/gui/assembly_gauges.png', u, w);
}

function getVisSlots(u as int, w as int) as SlotVisual {
  return SlotVisual.create(1, 1).addPart('requious:textures/gui/assembly_slots.png', u, w);
}

function arrow(ass as Assembly, x as int, y as int) as void {
  ass.setJEIDurationSlot(x, y, 'duration', SlotVisual.arrowRight());
}
