#modloaded littletiles

import crafttweaker.item.IIngredient;

scripts.lib.tooltip.desc.jei(<littletiles:recipeadvanced>, 'dont_put_into_ae');

// Storage tiles
recipes.remove(<littletiles:ltstorageblocktile>);
recipes.addShaped(<littletiles:ltstorageblocktile>, [
  [<chisel:factory:6>, <chisel:factory:6>, <chisel:factory:6>],
  [<chisel:factory:6>, <ore:chest>, <chisel:factory:6>],
  [<chisel:factory:6>, <chisel:factory:6>, <chisel:factory:6>]]);

// Tools
val ingrs = {
  '#': <randomthings:spectreplank>,       // Spectre Planks
  '`': <ore:nuggetPlatinum>,
  '╱': <ore:stickIron>,                   // Iron Rod
  'P': <computercraft:printout>,          // Printed Page
  'w': <ore:blockRockwool>,
  'M': <appliedenergistics2:material:39>, // ME Storage Housing
} as IIngredient[string];

craft.remake(<littletiles:hammer>,             [' ` ', ' #`', '#  '], ingrs);
craft.remake(<littletiles:recipeadvanced> * 4, ['P P', ' M ', 'P P'], ingrs);
craft.remake(<littletiles:saw>,                ['  #', ' #╱', '#╱ '], ingrs);
craft.remake(<littletiles:container>,          [' ` ', 'w w', ' w '], ingrs);
craft.remake(<littletiles:wrench>,             ['  `', ' # ', 'w  '], ingrs);
craft.remake(<littletiles:chisel>,             ['  `', ' # ', '#  '], ingrs);
craft.remake(<littletiles:colortube>,          [' w ', ' #w', '#  '], ingrs);
craft.remake(<littletiles:grabber>,            [' w ', 'wOw', ' # '], ingrs);

// Melt Water blocks
scripts.process.melt(<littletiles:lttransparentcoloredblock:5>, <liquid:water> * 1000);

// Add missed Dyable blocks recipes
val unique = scripts.lib.unique.Unique([
  <ore:dyeLightGray>,
  <rustic:clay_wall>,
  <rustic:clay_wall>,
]);

val hasRecipes = [12, 14] as int[];
for i in 0 .. 15 {
  if (hasRecipes has i) continue;
  recipes.addShaped('dyable block #' ~ i, <littletiles:ltcoloredblock>.definition.makeStack(i) * 4, unique.next());
}

for i in 0 .. 5 {
  recipes.addShaped('dyable block #' ~ (i + 14), <littletiles:ltcoloredblock2>.definition.makeStack(i) * 4, unique.next());
}

// Add hint about converting blocks
val curium_stalactite = <littletiles:multitiles>.withTag(mods.ctintegration.data.DataUtil.parse(
  '{tiles:[{boxes:[[I;3,0,2,5,8,4,-2146434816,131074],[I;5,2,3,7,8,5,-2147483072,-65538],[I;4,2,4,5,8,8,-2139092992,-196612],[I;1,6,4,4,8,6,-2142763904,-1,131074],[I;3,0,4,4,6,5,-2139092992,-1],[I;3,5,5,4,6,6,-2139229930,196607,196607,-131070,-2,196606,262143,-131069]],tile:{block:"nuclearcraft:fertile_isotope:4"}},{boxes:[[I;2,7,6,4,8,7],[I;2,5,3,3,8,4],[I;5,5,2,6,8,3],[I;2,6,2,3,8,3],[I;5,6,5,7,8,7],[I;5,3,5,6,6,6]],tile:{block:"minecraft:stone"}}],min:[I;1,0,2],size:[I;6,8,6],grid:8,count:12,structure:{blocks:[I;],name:"Curium-246 Stalactite",id:"fixed"}}'
));
scripts.jei.crafting_hints.addInsOutCatl(
  [curium_stalactite * 6],
  <nuclearcraft:fertile_isotope:4>,
  <littletiles:container>
);

val UUmetalOre = <littletiles:multitiles>.withTag(mods.ctintegration.data.DataUtil.parse(
  '{tiles:[{boxes:[[I;0,10,0,2,16,2],[I;0,7,0,1,10,3],[I;0,4,0,2,7,7],[I;0,2,0,2,4,3],[I;0,0,0,3,2,16],[I;13,6,0,16,8,1],[I;12,13,0,14,14,2],[I;0,7,5,1,8,7],[I;0,10,5,1,11,8],[I;14,0,0,16,3,16],[I;12,4,0,14,6,8],[I;11,8,0,15,10,15],[I;12,0,0,14,4,4],[I;11,4,0,12,6,16],[I;10,0,0,12,3,4],[I;10,0,8,12,2,16],[I;12,10,0,14,11,2],[I;13,11,0,14,13,1],[I;12,11,0,13,12,2],[I;15,15,0,16,16,13],[I;10,7,0,12,8,3],[I;9,4,0,10,6,6],[I;6,3,0,12,4,3],[I;8,0,13,10,1,16],[I;8,0,0,9,1,12],[I;8,1,0,10,2,12],[I;8,8,0,11,10,6],[I;8,6,2,10,8,6],[I;6,2,0,10,3,14],[I;6,5,0,8,10,14],[I;6,4,0,9,5,4],[I;4,3,1,6,4,15],[I;4,0,0,7,2,5],[I;4,0,12,6,2,16],[I;10,14,0,15,16,2],[I;10,14,4,12,15,8],[I;9,11,0,10,12,14],[I;6,10,0,10,11,10],[I;6,11,1,9,12,14],[I;6,12,1,10,13,14],[I;7,13,0,10,15,15],[I;7,15,0,10,16,7],[I;8,15,13,10,16,15],[I;11,15,6,13,16,8],[I;4,2,0,6,3,16],[I;5,14,6,6,15,12],[I;2,2,0,4,3,12],[I;6,13,0,7,16,14],[I;3,6,0,5,10,2],[I;3,11,0,5,15,2],[I;4,15,6,6,16,9],[I;1,10,12,4,11,13],[I;1,7,0,2,8,9],[I;3,15,0,4,16,8],[I;1,10,4,2,11,10],[I;15,5,6,16,6,10],[I;15,4,8,16,5,10],[I;15,4,12,16,5,16],[I;15,5,11,16,6,16],[I;15,3,7,16,4,16],[I;15,3,0,16,4,5],[I;15,8,0,16,9,4],[I;15,8,6,16,9,9],[I;15,9,5,16,10,15],[I;15,8,12,16,9,15],[I;15,9,0,16,15,3],[I;15,4,0,16,6,2],[I;14,3,0,15,4,7],[I;14,4,0,15,6,4],[I;14,4,6,15,6,7],[I;15,12,5,16,13,8],[I;15,11,12,16,12,15],[I;12,7,0,13,8,14],[I;14,10,0,15,14,10],[I;14,10,12,15,12,15],[I;13,15,14,16,16,15],[I;10,4,1,11,5,16],[I;10,5,0,11,6,16],[I;9,0,0,10,1,4],[I;9,0,5,10,1,11],[I;7,0,0,8,1,1],[I;7,1,0,8,2,10],[I;10,10,0,11,12,16],[I;8,5,0,9,6,6],[I;4,4,0,6,6,10],[I;4,0,7,5,1,8],[I;4,0,9,5,1,10],[I;7,15,8,8,16,15],[I;8,15,8,10,16,12],[I;11,15,4,12,16,5],[I;5,6,0,6,10,11],[I;3,3,1,4,4,4],[I;3,0,0,4,2,10],[I;3,0,11,4,2,16],[I;10,15,4,11,16,8],[I;5,12,0,6,16,1],[I;2,3,0,3,4,4],[I;2,7,0,3,10,6],[I;2,4,2,4,6,9],[I;2,6,1,3,7,9],[I;1,8,0,2,10,10],[I;2,15,0,3,16,7],[I;4,15,0,5,16,4],[I;2,10,0,3,15,3],[I;4,14,6,5,15,8],[I;0,12,2,2,16,7],[I;0,8,3,1,10,10],[I;10,6,1,16,7,2],[I;0,11,7,2,16,10],[I;2,7,6,3,15,9],[I;0,4,11,1,5,16],[I;0,12,11,3,16,12],[I;14,6,3,16,8,16],[I;10,6,3,12,8,14],[I;13,6,3,14,8,14],[I;12,6,2,13,7,14],[I;0,11,12,2,12,16],[I;0,12,12,4,16,16],[I;2,10,13,4,12,16],[I;0,5,10,2,10,16],[I;3,6,11,5,10,12],[I;0,6,9,2,8,10],[I;12,0,5,13,1,8],[I;13,0,4,14,1,8],[I;12,1,4,14,4,8],[I;10,2,4,11,3,16],[I;12,12,1,14,13,2],[I;9,3,3,10,4,6],[I;10,3,3,11,4,15],[I;6,1,12,10,2,16],[I;6,0,11,7,1,16],[I;7,0,2,8,1,16],[I;10,14,10,12,16,15],[I;8,3,6,10,10,14],[I;10,8,6,11,10,15],[I;6,3,4,8,5,14],[I;8,3,4,9,5,6],[I;4,1,5,6,2,10],[I;5,0,6,6,1,10],[I;12,14,2,13,16,5],[I;14,14,2,15,15,10],[I;13,12,2,14,15,15],[I;13,15,2,15,16,13],[I;6,10,10,8,11,15],[I;8,10,10,10,11,16],[I;12,14,5,13,15,8],[I;2,7,12,5,10,15],[I;2,5,12,5,7,16],[I;0,2,5,1,3,11],[I;1,2,3,2,3,12],[I;0,2,13,1,3,16],[I;4,14,14,7,16,15],[I;3,10,1,5,11,2],[I;2,10,3,5,15,4],[I;4,6,2,5,10,11],[I;3,6,2,4,10,8],[I;0,11,4,2,12,7],[I;2,10,4,3,15,6],[I;3,10,4,4,15,8],[I;4,10,4,5,14,8],[I;5,15,9,6,16,12],[I;2,4,9,4,16,10],[I;0,10,13,2,11,16],[I;3,15,11,5,16,12],[I;0,7,8,1,8,9],[I;15,10,3,16,12,8],[I;15,13,3,16,15,7],[I;15,5,2,16,6,4],[I;14,3,7,15,6,16],[I;12,0,8,14,6,16],[I;15,14,7,16,15,10],[I;14,12,10,16,15,15],[I;15,11,9,16,14,10],[I;15,10,14,16,11,15],[I;11,2,4,12,4,16],[I;12,10,2,14,12,15],[I;10,12,2,13,14,15],[I;11,10,1,12,11,16],[I;11,11,0,12,12,16],[I;1,4,10,5,5,16],[I;5,4,11,6,10,15],[I;2,5,10,5,6,12],[I;6,1,10,8,2,12],[I;4,10,10,5,14,14],[I;4,14,10,5,15,12],[I;0,3,4,4,4,16],[I;12,14,8,13,16,15],[I;5,14,1,6,16,4],[I;5,10,1,6,14,14],[I;3,10,11,4,15,12],[I;2,6,11,3,12,12],[I;4,10,9,5,16,10],[I;0,5,7,2,7,8],[I;1,4,7,2,5,8],[I;0,3,3,2,4,4],[I;13,7,1,16,8,3],[I;0,12,10,2,16,11],[I;13,6,2,16,7,3],[I;10,6,2,12,7,3],[I;13,6,15,14,8,16],[I;12,7,15,13,10,16],[I;2,11,12,4,12,13],[I;2,6,10,4,15,11],[I;0,6,8,2,7,9],[I;12,10,15,16,16,16],[I;13,11,1,14,12,2],[I;6,3,3,9,4,4],[I;11,3,3,12,4,4],[I;8,2,15,10,3,16],[I;8,2,14,10,4,15],[I;6,4,14,10,10,15],[I;6,0,5,7,2,10],[I;7,10,15,8,11,16],[I;6,11,14,8,12,16],[I;8,11,14,10,13,15],[I;9,15,7,10,16,8],[I;8,11,15,10,16,16],[I;5,12,14,8,13,16],[I;1,2,12,4,3,16],[I;6,13,14,7,14,16],[I;3,10,2,5,15,3],[I;4,14,15,8,16,16],[I;4,7,15,5,10,16],[I;2,8,15,4,10,16],[I;2,15,10,5,16,11],[I;15,11,8,16,13,9],[I;12,6,14,14,8,15],[I;14,15,13,16,16,14],[I;11,13,15,12,16,16],[I;10,12,15,11,16,16],[I;10,8,15,12,10,16],[I;13,8,15,16,10,16],[I;5,4,10,6,6,11],[I;7,13,15,8,14,16],[I;8,7,15,10,10,16],[I;5,5,15,8,10,16],[I;8,5,15,10,6,16],[I;9,4,15,10,5,16],[I;3,1,10,4,2,11],[I;4,12,14,5,14,16],[I;5,13,14,6,14,15],[I;3,6,8,4,15,9],[I;4,10,8,5,15,9]],tile:{block:"minecraft:stone"}},{boxes:[[I;0,10,4,1,11,5],[I;10,6,0,13,7,1],[I;10,0,5,12,2,8],[I;10,6,14,12,8,16],[I;8,6,0,10,8,2],[I;4,0,11,6,2,12],[I;10,12,1,12,14,2],[I;10,13,0,12,14,1],[I;3,3,0,6,4,1],[I;5,11,0,9,12,1],[I;6,12,0,13,13,1],[I;3,10,0,6,11,1],[I;2,4,0,4,6,2],[I;11,10,0,12,11,1],[I;10,4,0,11,5,1],[I;4,0,6,5,1,7],[I;2,6,0,3,7,1],[I;0,10,2,2,12,4],[I;0,7,3,1,8,5],[I;0,4,7,1,5,11],[I;0,2,3,1,3,5],[I;0,2,11,1,3,13],[I;0,11,10,2,12,12],[I;0,10,8,1,11,13],[I;0,5,8,2,6,10],[I;1,4,8,2,5,10],[I;10,14,2,12,16,4],[I;4,14,4,6,16,6],[I;1,10,10,2,11,12],[I;15,4,10,16,5,12],[I;15,3,5,16,4,7],[I;15,8,4,16,9,6],[I;15,8,9,16,9,12],[I;15,9,3,16,10,5],[I;15,12,3,16,13,5],[I;15,4,2,16,5,8],[I;15,5,4,16,6,6],[I;14,4,4,15,6,6],[I;15,10,8,16,11,14],[I;15,13,7,16,14,9],[I;15,11,10,16,12,12],[I;14,10,10,15,12,12],[I;8,0,12,10,1,13],[I;6,2,14,8,4,16],[I;10,14,8,12,16,10],[I;4,14,12,6,16,14],[I;4,10,14,6,12,16],[I;2,15,7,3,16,9],[I;0,7,7,1,8,8],[I;12,6,15,13,7,16],[I;9,0,4,13,1,5],[I;10,1,4,12,2,5],[I;8,3,15,11,4,16],[I;4,3,15,6,4,16],[I;4,0,5,6,1,6],[I;6,10,15,7,11,16],[I;7,15,7,9,16,8],[I;11,15,5,13,16,6],[I;2,7,15,4,8,16],[I;15,5,10,16,6,11],[I;13,15,13,14,16,14],[I;11,12,15,12,13,16],[I;9,0,11,10,1,12],[I;7,0,1,8,1,2],[I;4,0,8,5,1,9],[I;3,0,10,7,1,11],[I;4,1,10,6,2,11],[I;8,15,12,10,16,13],[I;5,4,15,9,5,16],[I;8,6,15,10,7,16],[I;5,13,15,6,14,16],[I;3,15,8,4,16,9]],tile:{block:"tconevo:metal_block:8"}}],min:[I;0,0,0],size:[I;16,16,16],display:{Name:"UU-Metal Ore"},count:315,structure:{name:"UU-Metal Ore",id:"fixed"}}'
));
scripts.jei.crafting_hints.addInsOutCatl(
  [UUmetalOre * 13],
  <tconevo:metal_block:8>,
  <littletiles:container>
);
